.\" $NetBSD: wctomb.3,v 1.4 2004/01/24 16:58:54 wiz Exp $
.\"
.\" Copyright (c)2002 Citrus Project,
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd February 3, 2002
.Dt WCTOMB 3
.Os
.Sh NAME
.Nm wctomb
.Nd converts a wide character to a multibyte character
.Sh LIBRARY
.Lb libc
.Sh SYNOPSIS
.In stdlib.h
.Ft int
.Fn wctomb "char * s" "const wchar_t wchar"
.Sh DESCRIPTION
The
.Fn wctomb
converts the wide character
.Fa wchar
to the corresponding multibyte character, and stores it in the array
pointed to by
.Fa s .
.Fn wctomb
may store at most
.Dv MB_CUR_MAX
bytes in the array.
.Pp
In state-dependent encoding,
.Fn wctomb
may store the special sequence to change the conversion state
before an actual multibyte character into the array pointed to by
.Fa s .
If
.Fa wchar
is a nul wide character
.Pq Sq \e0 ,
this function sets its own internal state to an initial conversion state.
.Pp
Calling any other functions in
.Lb libc
never changes the internal state of
.Fn wctomb ,
except changing the
.Dv LC_CTYPE
category of the current locale by calling
.Xr setlocale 3 .
Such
.Xr setlocale 3
calls cause the internal state of this function to be indeterminate.
.Pp
The behaviour of
.Fn wctomb
is affected by the
.Dv LC_CTYPE
category of the current locale.
.Pp
There is one special case:
.Bl -tag -width 012345678901
.It s == NULL
.Fn wctomb
initializes its own internal state to an initial state, and
determines whether the current encoding is state-dependent.
This function returns 0 if the encoding is state-independent,
otherwise non-zero.
In this case,
.Fa wchar
is completely ignored.
.El
.Sh RETURN VALUES
Normally,
.Fn wctomb
returns:
.Bl -tag -width 012345678901
.It positive
Number of bytes for the valid multibyte character pointed to by
.Fa s .
There are no cases that the value returned is greater than
.Fa n
or the value of the
.Dv MB_CUR_MAX
macro.
.It -1
.Fa wchar
is an invalid wide character.
.El
.Pp
If
.Fa s
is equal to
.Dv NULL ,
.Fn mbtowc
returns:
.Bl -tag -width 0123456789
.It 0
The current encoding is state-independent.
.It non-zero
The current encoding is state-dependent.
.El
.Sh ERRORS
No errors are defined.
.Sh SEE ALSO
.Xr setlocale 3
.Sh STANDARDS
The
.Fn wctomb
function conforms to
.St -ansiC .
